import sys
sys.path.append('I:\work3\Output\Scripts\Lib')

from System.Collections.Generic import List
from System import Byte

import time
#import random

global timer
timer = time.time()
Journal.Clear()

################
##Misc Constants
################
global AllowedAxes
AllowedAxes = [0x0F43]
global ToolToUse
ToolToUse = Items.FindByID(0x0F43, 0, Player.Backpack.Serial)
global swingCD
swingCD = 0

#if the range of character is over this number, it will try to use a moongate
MaxPathFindRange = 600 

#menu button on the moongate gump for each city (UO Outlands)
Andaria = 10 
Cambria = 11
HorseshoeBay = 12
Outpost = 13
Prevalia = 14
Terran = 15
ShelterIsland = 16
CorpseCreek = 17
TheArena = 18

####################################
## These are things to edit yourself
####################################

global BoardAmountToDropOff
#the number of boards to trigger a drop off run -- keep this reasonably high unless testing
BoardAmountToDropOff = 1000  
global ChopIntoBoardsWeight
#the weight at which you chop logs into boards, make sure you arent over this weight by default
ChopIntoBoardsWeight = Player.MaxWeight-50


#########################################################################
## Waypoint lists to navigate to and take a snapshot of all trees in area
#########################################################################

AndariaLumberJackCarpenterArea = [(2234,703),(2244,729),(2220,742)]
ShelterIslandLumberJackAreas = [(1923,2649), (1915,2571),(1871,2564),(1954,2575),(2006,2577),(2022,2600)]
PrevaliaLJWest= [(1396,1321),(1397,1357),(1400,1390),(1399,1427),(1397,1462)]
HorseShoeBayEast = [(2098,2249),(2099,2282),(2083,2318),(2114,2337),
(2118,2384),(2145,2388)] #out of town but little spawn
AndariaOutsideCity = [(2039, 528),(2039, 564),(2073, 579),(2105, 579),(2164,558),(2165,529),(2173,506),(2187,479),(2141,517),] # 
TerranLumberJackAreaSouth = [(773,1572),(739,1557),(722,1471),(734,1418)]
HorseShowBayWest = [(1992,2280),(1967,2259),(1933,2260),(1933,2215),(1913,2213),(1890,2216),
(1871,2215),(1887,2187)]

Test = [(2855,3538)]

global WayPoints
WayPoints = Test # Which Waypoint list to use from above 
                                    #(make sure to make a path to the moongate and back below!)


#########################################################################
#########################################################################

#Path from LJ area to go and drop off boards via moongate
global MoongateDes
global MoongateLoc
global PathToCrafterUsingMoongate
TerranAreaToMoonGate = [(784,1491),(801,1492),(858,1540),(865,1569)]
PathToCrafterUsingMoongate = TerranAreaToMoonGate

##Path after boards are dropped and banked to go back to the moongate
global PathBackToHarvestUsingMoongateUsingMoongate
PathBackToHarvestUsingMoongate = [(2189,643)]

#Which city to select when on its way to lumberjack
global MoonGateMenuForLJ
MoonGateMenuForLJ = Terran 
#Which city to select for drop off/bank
global MoonGateMenuForCrafter
MoonGateMenuForCrafter = Andaria

#list of Player Serials who you want to give resources to (use -inspect in game to find his serial)
global CrafterSerial
CrafterSerial = 0x0000056C

#What tile to drop off boards at
global BoardDropOff
BoardDropOff = [(2231, 707)] 

#What tile to bank resources at
global BankWayPoints
BankWayPoints = [(2189, 631)]


##########################
## Options
##########################

ResourcesYouWantInBank = ['0x1BF2', '0x1BD7'] #Resources you want to put in the bank during bank runs

itemcd = 600 #the delay between item movements
wft = 2000 #wait for target delay
harvestcd = 1000 #harvest delay between attempts

################################
## DO NOT EDIT (change it at your own risk)
################################
        
invalidTrees = []

##Scan StaticTile Parameters
ScanRadius = 15
TreeStaticID = [3221, 3222, 3225, 3227, 3228, 3229, 3210, 3238, 3240, 3242, 3243, 3267, 3268, 3272, 3273, 3274, 3275, 3276, 3277, 3280, 3283, 3286, 3288, 3290, 3293, 3296, 3299, 3302, 3320, 3323, 3326, 3329, 3365, 3367, 3381, 3383, 3384, 3394, 3395, 3417, 3440, 3461, 3476, 3478, 3480, 3482, 3484, 3486, 3488, 3490, 3492, 3496]
EquipAccettaDelay = 1000
TimeoutOnWaitAction = 4000
ChopDelay = 1000
RuneBookBanca = 0x41EA8DEE # Runebook for bank
RuneBookAlberi = 0x41EA8DEE # Runebook for tree spots
RecallPause = 3000 
DragDelay = 1200
LogID = 0x1BDD
OtherResourceID = [12687, 12697, 12127, 12688, 12689]
LogBag = 0x401FA597 # Serial of log bag in bank
OtherResourceBag = 0x40191C19 # Serial of other resource in bank
WeightLimit = 385
BankX = 2051
BankY = 1343

## System Variables
tileinfo = List[Statics.TileInfo]
treeposx = []
treeposy = []
treeposz = []
treegfx = []
treenumber = 0
blockcount = 0
lastrune = 5
onloop = True


def RangeTree( spotnumber ):
    if (Player.Position.X - 1) == treeposx[spotnumber] and (Player.Position.Y + 1) == treeposy[spotnumber]:
        return True
    elif (Player.Position.X - 1) == treeposx[spotnumber] and (Player.Position.Y - 1) == treeposy[spotnumber]:
        return True
    elif (Player.Position.X + 1) == treeposx[spotnumber] and (Player.Position.Y + 1) == treeposy[spotnumber]:
        return True
    elif (Player.Position.X + 1) == treeposx[spotnumber] and (Player.Position.Y - 1) == treeposy[spotnumber]:
        return True
    elif Player.Position.X == treeposx[spotnumber] and (Player.Position.Y - 1) == treeposy[spotnumber]:
        return True    
    elif Player.Position.X == treeposx[spotnumber] and (Player.Position.Y + 1) == treeposy[spotnumber]:   
        return True     
    elif Player.Position.Y == treeposy[spotnumber] and (Player.Position.X - 1) == treeposx[spotnumber]:
        return True    
    elif Player.Position.Y == treeposy[spotnumber] and (Player.Position.X + 1) == treeposx[spotnumber]:   
        return True    
    else:
        return False

  
def ScanStatic( ): 
    global treenumber
    Misc.SendMessage("--> Initiating Tile Scan", 77)
    minx = Player.Position.X - ScanRadius
    maxx = Player.Position.X + ScanRadius
    miny = Player.Position.Y - ScanRadius
    maxy = Player.Position.Y + ScanRadius

    while miny <= maxy:
        while minx <= maxx:
            tileinfo = Statics.GetStaticsTileInfo(minx, miny, Player.Map)
            if tileinfo.Count > 0:
                for tile in tileinfo:
                    for staticid in TreeStaticID:
                        if staticid == tile.StaticID:
                            Misc.SendMessage('--> Tree X: %i - Y: %i - Z: %i' % (minx, miny, tile.StaticZ), 66)
                            treeposx.Add(minx)
                            treeposy.Add(miny)
                            treeposz.Add(tile.StaticZ)
                            treegfx.Add(tile.StaticID)
            else:
                Misc.NoOperation()
            minx = minx + 1
        minx = Player.Position.X - ScanRadius            
        miny = miny + 1
    treenumber = treeposx.Count    
    Misc.SendMessage('--> Total Trees: %i' % (treenumber), 77)    

    
def MoveToTree( spotnumber ):
    timer = time.time()
    
    if (treeposx[spotnumber], treeposy[spotnumber]) in invalidTrees:
        Misc.SendMessage('Previously unreachable tree is being skipped')
        return False
    else:
        Misc.SendMessage('--> Moving to TreeSpot: %i' % (spotnumber+1), 77)
        
        listNextToTreeCoords = []
        impass = False
        skiptree = False
        
        for y in range(-1, 1, 1):
            for x in range(-1, 1, 1):
                landID = Statics.GetLandID(treeposx[spotnumber]+x, treeposy[spotnumber]+y, Player.Map)
                if Statics.GetLandFlag(landID, 'Impassable'):
                    impass = True
                tileinfo = Statics.GetStaticsTileInfo(treeposx[spotnumber]+x, treeposy[spotnumber]+y, Player.Map)
                for t in tileinfo:
                    if Statics.GetTileFlag(t.StaticID, 'Impassable'):
                        impass = True
                if not impass: 
                    listNextToTreeCoords = [treeposx[spotnumber]+x, treeposy[spotnumber]+y]
                    break
        
        DestinationValid = True            
        if listNextToTreeCoords != []:
            Misc.SendMessage(str(listNextToTreeCoords))
            routeNextTree = PathFinding.Route()
            routeNextTree.X = listNextToTreeCoords[0]
            routeNextTree.Y = listNextToTreeCoords[1]
            routeNextTree.DebugMessage = False;
            routeNextTree.StopIfStuck  = False;
            routeNextTree.MaxRetry     = 2;
            DestinationValid = PathFinding.Go(routeNextTree)      
        else:
            Misc.SendMessage('Tree is blocked by surrounding land, adding tree to ignore list', 35)
            invalidTrees.Add((treeposx[spotnumber], treeposy[spotnumber]))
            skiptree = True
            
        if not DestinationValid:
            Misc.SendMessage('Tree pathfind location is invalid, adding tree to ignore list', 35)
            invalidTrees.Add((treeposx[spotnumber], treeposy[spotnumber]))
            skiptree = True
            
            
        while not RangeTree(spotnumber):
            CheckEnemy()  
            Misc.Pause(10)
            if time.time() - timer >= 30 and DestinationValid: 
                Misc.SendMessage('--> PathFinding to tree timed out for some reason, skipping tree and adding it to ignore list', 77)
                invalidTrees.Add((treeposx[spotnumber], treeposy[spotnumber]))
                break 
            elif skiptree:
                break 
            else:
                Misc.NoOperation() 
        if RangeTree(spotnumber): 
            Misc.SendMessage('--> Reached TreeSpot: %i' % (spotnumber+1), 77)
            return True

def CheckEnemy( ):
    DetectCombat()
    if Player.Hits == Player.HitsMax and Misc.ScriptStatus('HealDEX.py'): 
        Misc.ScriptStop('HealDEX.py')
        Misc.Pause(itemcd)
        if Target.HasTarget(): Target.Cancel()
    return;    


def DetectCombat():
    global swingCD
    
    swingCD = 0
    mob = False
    filAgro = Mobiles.Filter()
    filAgro.Enabled = True
    filAgro.RangeMax = 8
    filAgro.Friend = False
    filAgro.Notorieties = List[Byte](bytes([3,4,5,6])) #1:cyan 2:green 3:gray 4:criminal 5:orange 6:red 7:yellow          
    AgroMobs = Mobiles.ApplyFilter(filAgro)
    
    count = 0
    for a in AgroMobs:
        if a.WarMode == True:
            Misc.SendMessage('Incoming hostile! Fighting', 35)
            mob = True
            Misc.FocusUOWindow()
            Misc.Beep()
            Misc.Pause(800)
            Misc.Beep()
            Misc.Pause(800)
            Misc.Beep()
            Misc.Pause(800)            
#            FightTheAgroMob(a)
#    if mob: 
#        DetectCombat()
#    else:
#        return False
        
            

def EvasiveManuevers(enemyMobile):
    global swingCD
    
    Offset = [enemyMobile.Position.X-Player.Position.X, enemyMobile.Position.Y-Player.Position.Y]
    Runaway = PathFinding.Route()
    Runaway.DebugMessage = False;
    Runaway.StopIfStuck  = False;
    Runaway.MaxRetry     = 0;
    if (abs(Offset[0]) <= 1 and abs(Offset[1]) <= 1):
        if swingCD <= 0: swingCD = 2000
      
        Runaway = PathFinding.Route()
        x = random.randint(-1,1)
        y = random.randint(-1,1)
        if x is 0 and y is 0:
            x = 1 if random.random() < 0.5 else -1
            y = 1 if random.random() < 0.5 else -1
        
        if Player.Hits < Player.HitsMax-20:
            scaledDist1 = int((2+2*((Player.HitsMax - Player.Hits)//20)))
            scaledDist2 = int((3+3*((Player.HitsMax - Player.Hits)//20)))
            Misc.SendMessage('Scaled distance x is %i y is %i' % (scaledDist1,scaledDist2), 89)
            gotoX = (enemyMobile.Position.X + (random.randint(scaledDist1,scaledDist2)*x))
            gotoY = (enemyMobile.Position.Y + (random.randint(scaledDist1,scaledDist2)*y))
        else:
            gotoX = (enemyMobile.Position.X + (random.randint(3,4)*x))
            gotoY = (enemyMobile.Position.Y + (random.randint(3,4)*y))
             
        Runaway.X = gotoX
        Runaway.Y = gotoY
  
        if not PathFinding.Go(Runaway):
            listNextToRunAway = []
            impass = False
            Misc.SendMessage('Runaway blocked, finding closest tile', 89)
            for y in range(-1, 1, 1):
                for x in range(-1, 1, 1):
                    landID = Statics.GetLandID(gotoX+x, gotoY+y, Player.Map)
                    if Statics.GetLandFlag(landID, 'Impassable'):
                        impass = True
                    tileinfo = Statics.GetStaticsTileInfo(gotoX+x, gotoY+y, Player.Map)
                    for t in tileinfo:
                        if Statics.GetTileFlag(t.StaticID, 'Impassable'):
                            impass = True
                    if not impass: 
                        listNextToRunAway = [gotoX+x, gotoY+y]
                        break
            if len(listNextToRunAway)>1: 
                Runaway.X = listNextToRunAway[0]
                Runaway.Y = listNextToRunAway[1]
                PathFinding.Go(Runaway)
            else:
                Misc.SendMessage('Failed to find a navigation point near mob', 35)
                swingCD = 2000
            
    elif (Player.Hits < (Player.HitsMax//2)) and (abs(Offset[0])<=10 and abs(Offset[1])<=10):
        Misc.SendMessage('Maintain distance from mob until healed', 89)
        gotoX = (Player.Position.X - Offset[0]//2)
        gotoY = (Player.Position.Y - Offset[1]//2)
         
        Runaway.X = gotoX
        Runaway.Y = gotoY
        Runaway.DebugMessage = False;
        Runaway.StopIfStuck  = False;
        Runaway.MaxRetry     = 0;
        if not PathFinding.Go(Runaway):
            listNextToRunAway = []
            impass = False
            Misc.SendMessage('Runaway blocked, finding closest tile', 89)
            for y in range(-1, 1, 1):
                for x in range(-1, 1, 1):
                    landID = Statics.GetLandID(gotoX+x, gotoY+y, Player.Map)
                    if Statics.GetLandFlag(landID, 'Impassable'):
                        impass = True
                    tileinfo = Statics.GetStaticsTileInfo(gotoX+x, gotoY+y, Player.Map)
                    for t in tileinfo:
                        if Statics.GetTileFlag(t.StaticID, 'Impassable'):
                            impass = True
                    if not impass: 
                        listNextToRunAway = [gotoX+x, gotoY+y]
                        break
            if len(listNextToRunAway)>1: 
                Runaway.X = listNextToRunAway[0]
                Runaway.Y = listNextToRunAway[1]
                PathFinding.Go(Runaway)
            else:
                Misc.SendMessage('Failed to find a navigation point near mob', 35)
                swingCD = 2000
        
def ChargeIn(enemyMobile):
    global swingCD
    
    Player.Attack(enemyMobile)
    Offset = [enemyMobile.Position.X-Player.Position.X, enemyMobile.Position.Y-Player.Position.Y]
    if abs(Offset[0]) > 1 or abs(Offset[1]) > 1:
        
        x = (Player.Position.X + Offset[0]-1) if Offset[0] > 0 else (Player.Position.X + Offset[0]+1)
        y = (Player.Position.Y + Offset[1]-1) if Offset[1] > 0 else (Player.Position.Y + Offset[1]+1)
        
        Misc.SendMessage('offset x is %i and y is %i' % (x,y))
        charge = PathFinding.Route()
        charge.X = x
        charge.Y = y
        charge.DebugMessage = False;
        charge.StopIfStuck  = False;
        charge.MaxRetry     = 0;
        hit = PathFinding.Go(charge)
        if not hit and not (Player.Position.X == x and Player.Position.Y == y):
            listNextToEnemy = []
            impass = False
            Misc.SendMessage('except called')
            for y in range(-1, 1, 1):
                for x in range(-1, 1, 1):
                    landID = Statics.GetLandID(enemyMobile.Position.X+x, enemyMobile.Position.Y+y, Player.Map)
                    if Statics.GetLandFlag(landID, 'Impassable'):
                        impass = True
                    tileinfo = Statics.GetStaticsTileInfo(enemyMobile.Position.X+x, enemyMobile.Position.Y+y, Player.Map)
                    for t in tileinfo:
                        if Statics.GetTileFlag(t.StaticID, 'Impassable'):
                            impass = True
                    if not impass: 
                        listNextToEnemy = [enemyMobile.Position.X+x, enemyMobile.Position.Y+y]
                        break
            if len(listNextToEnemy)>1: 
                charge = PathFinding.Route()
                charge.X = listNextToEnemy[0]
                charge.Y = listNextToEnemy[1]
                PathFinding.Go(charge)
            else:
                Misc.SendMessage('Failed to find a navigation point near mob', 35)
                swingCD = 2000
                return False
        Misc.Pause(10)
        Offset = [enemyMobile.Position.X-Player.Position.X, enemyMobile.Position.Y-Player.Position.Y]

def FightTheAgroMob(CurrentEnemy):
    global swingCD
    
    while not Player.IsGhost:
        Misc.Pause(50)
        if Player.Hits != Player.HitsMax and not Misc.ScriptStatus('HealDEX.py'): Misc.ScriptRun('HealDEX.py')
        if swingCD <= 0 and Player.Hits > (Player.HitsMax//2):
            Misc.SendMessage('Charge in %s' % (CurrentEnemy.Name), 77)  
            ChargeIn(CurrentEnemy)
        else:
            swingCD -= 50
        EvasiveManuevers(CurrentEnemy)
        enemyToTest = Mobiles.FindBySerial(CurrentEnemy.Serial)
        if enemyToTest is None:
            Misc.SendMessage('Dead',77)    
            return False
        
        
        
def FindByItemIDInPack(itemID, container = Player.Backpack):
    global foundItem
    foundItem = False
    
    for c in container.Contains:
        if c.ItemID == itemID:
            foundItem = c
            return foundItem
        elif c.IsContainer: 
            searchmore = FindByItemIDInPack(itemID, c)
            if foundItem: 
                foundItem = searchmore
                return foundItem  
    return foundItem
        
def EquipAxeOrTool():
    LeftHandItem = Player.GetItemOnLayer('LeftHand')
    if LeftHandItem is None:
        toolfound = FindByItemIDInPack(0x0F44)
        if toolfound:
            for i in AllowedAxes:   
                axeweapon = FindByItemIDInPack(i)
                if axeweapon: break
            Misc.Pause(itemcd)
            if axeweapon:
                Player.EquipItem(axeweapon)
            else:
                Player.EquipItem(toolfound)
            Misc.Pause(itemcd)
            return toolfound
        else:
            Misc.SendMessage('No hatchets found in backpack', 55)
    elif not LeftHandItem.ItemID in AllowedAxes:
        Player.UnEquipItemByLayer('LeftHand')
        Misc.Pause(itemcd)
        toolfound = FindByItemIDInPack(0x0F44)
        if toolfound:
            for i in AllowedAxes:   
                axeweapon = FindByItemIDInPack(i)
                if axeweapon: break
            Misc.Pause(itemcd)
            if axeweapon:
                Player.EquipItem(axeweapon)
            else:
                Player.EquipItem(toolfound)
            Misc.Pause(itemcd)
            return toolfound
        else:
            Misc.SendMessage('No hatchets found in backpack', 55)
    else:
        toolfound = FindByItemIDInPack(0x0F43)
        if toolfound:
            for i in AllowedAxes:   
                axeweapon = FindByItemIDInPack(i)
                if axeweapon: break
            Misc.Pause(itemcd)
            if axeweapon:
                Player.EquipItem(axeweapon)
            else:
                Player.EquipItem(toolfound)
            Misc.Pause(itemcd)
            return toolfound
        else:
            Misc.SendMessage('No hatchets found in backpack', 55)

def HarvestResources(spotnumber):
    Journal.Clear()
    Misc.SendMessage('Harvesting resources at tree %i' % (spotnumber+1), 77)
    CutTree(spotnumber, True)
    if (Player.Weight>=ChopIntoBoardsWeight): 
        OverWeight()
        Misc.Pause(harvestcd)
    if (Items.BackpackCount(0x1BD7, -1) >= BoardAmountToDropOff):
        Misc.SendMessage('Board limit reached MoveToCarpenter')
        MoveToCarpenter()
  
def CutTree( spotnumber, UseTool = True ):
    global ToolToUse
    
    if Target.HasTarget():
        Misc.SendMessage("--> Cancelling target", 77)
        Target.Cancel()
        Misc.Pause(itemcd)
    else:
        Misc.NoOperation()    
      
    if UseTool:
        Journal.Clear()
        ToolToUse = Items.FindBySerial(ToolToUse.Serial)
        if not ToolToUse is None:
            LeftHandItem = Player.GetItemOnLayer('LeftHand')
            if None == LeftHandItem:
                Player.EquipItem(ToolToUse.Serial)
                Misc.Pause(1000)
                LeftHandItem = ToolToUse
            if LeftHandItem.Serial != ToolToUse.Serial:
                Player.UnEquipItemByLayer('LeftHand')
                Misc.Pause(1000)
                Player.EquipItem(ToolToUse.Serial)
                Misc.Pause(1000)
        #Items.UseItem(ToolToUse.Serial)
        #Target.WaitForTarget(wft)
        #Target.TargetExecute(Player.Serial)
        else:
            Misc.SendMessage('Hatchet is not updating, possibly out', 35)
    lock = 1
    unlock = 25000
    chop = False
    
    CheckEnemy()
    
    while lock == 1:
        if Journal.Search("You do not see any"):
            Misc.SendMessage("--> Next tree", 77)
            lock = 0
        elif Journal.Search("You hack at the tree"):
            lock = 0
            chop = True
        elif Journal.Search("You chop some"):    
            lock = 0
            chop = True
        else:
            unlock = unlock - 50
            if Gumps.HasGump(): GumpCheck()
            if unlock <= 0:
                Misc.SendMessage('CutTree Timed Out, moving to next tree', 77)
                lock = 0
            else:
                Misc.NoOperation()
            Misc.Pause(50)               
    if chop: CutTree(spotnumber, True)
        
def GumpCheck():
    Misc.FocusUOWindow()
    Misc.Beep()
    Misc.Pause(800)
    Misc.Beep()
    Misc.Pause(800)
    Misc.Beep()
    Misc.Pause(800)
    Misc.Pause(5000)
    return;
#    while Gumps.CurrentGump() == 1269897018:
#        RandomDelay = random.randint(1000,3000)
#        Misc.Pause(RandomDelay)
#        for i in Gumps.LastGumpGetLineList():
#            if i == 'Click Again to Confirm': 
#                Gumps.SendAction(Gumps.CurrentGump(), 2)
#                break
#            elif i == 'Match the Symbols':
#                Misc.ScriptRun('bypass.py')
#                RandomDelay = random.randint(4000,9000)
#                Misc.Pause(RandomDelay)
#                Gumps.SendAction(Gumps.CurrentGump(), 2)
#                break
#        Gumps.WaitForGump(1269897018, 2000)

def OverWeight():
    if (Items.BackpackCount(0x1BDD,-1)>=10):
        for i in Player.Backpack.Contains:
            if i.ItemID == 0x1BDD:
                Misc.Pause(itemcd)
                Items.UseItemByID(0x0F44,-1) ## Chop log into boards
                Target.WaitForTarget(2000)
                Target.TargetExecute(i)
        Misc.Pause(2000)

    
def MoveToCarpenter():
    global currentNode 
    currentNode -= 1
    Misc.SendMessage('Current LJ Node saved as %i' % (currentNode))
    Misc.SetSharedValue('PrevCoords', currentNode)
    
    while (Player.Position.X, Player.Position.Y) != BoardDropOff[len(BoardDropOff)-1]:    
        Misc.SendMessage('Pathfind to the BoardDropOff', 77)
        MoveToNextNode(BoardDropOff, True)
        Misc.Pause(itemcd)

    Misc.SendMessage('Arrived at the drop tile for crafter, waiting for him to equip hatchet',77)
    BoardsOnGround = False
    Retrieve = False
    
    Crafter = Mobiles.FindBySerial(CrafterSerial)
    if Crafter == None: 
        Misc.SendMessage('Crafter is not present for drop off', 77)
        Misc.Pause(2000) ## Crafter not on screen... Bank resources?
        timer = time.time()
        BankTimeOut = 30
        while time.time() - timer <= BankTimeOut and Crafter == None:
            Misc.SendMessage('Waiting for crafter %i seconds left until forcing bank' % (BankTimeOut - (time.time() - timer)))
            Misc.Pause(1000)
            Crafter = Mobiles.FindBySerial(CrafterSerial)
        if Crafter == None: 
            Bank()
            ReturnToHarvestPoint()
            
    else:    
        for i in Crafter.Contains:
            if i.ItemID == 0x0F44:
                Misc.SendMessage('Hatchet found dropping resources')
                lisBoards = List[int](int(x, 16) for x in ['0x1BD7'])     
                Journal.Clear()
                for i in Player.Backpack.Contains:
                    if i.ItemID in lisBoards and i.Hue == 0x0000:
                        Items.DropItemGroundSelf(i,0) ## Drop boards on ground
                        Misc.Pause(itemcd)
                        BoardsOnGround = True
    if BoardsOnGround: 
        timer = time.time()
        while time.time() - timer < 10:
            Misc.Pause(itemcd)
            filBoards = Items.Filter()
            filBoards.Enabled = True
            filBoards.OnGround = True
            filBoards.Movable = True
            filBoards.Graphics = List[int](int('0x1BD7',16))
            filBoards.RangeMax = 0
            lisBoardsOnGround = Items.ApplyFilter(filBoards)
            if lisBoardsOnGround == None:
                Retrieve = False
                break
            else:
                Retrieve = True
        if Retrieve:
            for l in lisBoardsOnGround:
                Items.Move(l, Player.Backpack, 0)
                Misc.Pause(itemcd)
        Bank()
        ReturnToHarvestPoint()
        Misc.Pause(itemcd)
    return True
    
def Bank(SaveCurrentNode = False):
    global currentNode
    
    if SaveCurrentNode:
        currentNode -= 1
        Misc.SendMessage('Current LJ Node saved as %i' % (currentNode))
        Misc.SetSharedValue('PrevCoords', currentNode)
        
    while (Player.Position.X, Player.Position.Y) is not BankWayPoints[len(BankWayPoints)-1]:
        Misc.SendMessage('Moving to bank -->', 77)
        ArrivedAtBank = MoveToNextNode(BankWayPoints, True)
        Misc.Pause(itemcd)
        
        if ArrivedAtBank: 
            Misc.SendMessage('Arrived at bank', 77)
            Player.ChatSay(52,'Bank')
            Misc.Pause(600)
            
            lisResourcesToBank = List[int](int(x, 16) for x in ResourcesYouWantInBank)
            
            for l in Player.Backpack.Contains:
                if l.ItemID in lisResourcesToBank:
                    Items.Move(l, Player.Bank,0)
                    Misc.Pause(itemcd)
            break
    return True

def ReturnToHarvestPoint():
    global currentNode
    if Misc.CheckSharedValue('PrevCoords') :
        currentNode = Misc.ReadSharedValue('PrevCoords')
        Misc.RemoveSharedValue('PrevCoords')
    else:
        Misc.SendMessage('Error in return to harvest point, no previous node saved', 35)  
    MoveToNextNode([WayPoints[currentNode]], True)
    currentNode += 1
    
def CheckPathFindRange(TupleXYGoTo):
    if abs(Player.Position.X - TupleXYGoTo[len(TupleXYGoTo)-2]) > MaxPathFindRange or abs(Player.Position.Y - TupleXYGoTo[len(TupleXYGoTo)-1]) > MaxPathFindRange:
        Misc.SendMessage('Out of Range: Move To Moongate', 35)
        Misc.Pause(itemcd)
        return True
    else:
        return False
            
def UseMoongate(Destination, Confirm = 2):
    MoonGate = None
    
    filMoonGate = Items.Filter()
    filMoonGate.Enabled = True
    filMoonGate.OnGround = True
    filMoonGate.Movable = False
    filMoonGate.Graphics = List[int]((0x0F6C,0))
    filMoonGate.Hues = List[int]((0x0B05,0)) 
    filMoonGate.RangeMax = 2
    lisMoonGate = Items.ApplyFilter(filMoonGate)
    for l in lisMoonGate:
        MoonGate = l 
        
    if MoonGate is not None:
        if Gumps.HasGump():
            Misc.Pause(itemcd)
            Gumps.CloseGump(3773199800)
        Misc.SendMessage('Moongate used to go to %i' % (Destination))
        Items.UseItem(MoonGate)
    else:
        Misc.SendMessage('Moongate use was attempted but no moongate in range', 35)
    Gumps.WaitForGump(3773199800, 2000)
    Gumps.SendAction(3773199800, Destination)
    Misc.Pause(itemcd)
    Gumps.WaitForGump(3773199800, 2000)
    Gumps.SendAction(3773199800, 2)

def MoveToNextNode(PathToFollow, RangeCheck = True):
 
    start = 0
    end = len(PathToFollow)
    current = start
    OutOfRange = False
    
    while current < end:
        if RangeCheck: 
            OutOfRange = CheckPathFindRange(PathToFollow[current])
            if OutOfRange: 
                GoToMoonGate(PathToFollow[current])
        ArrivedAtNextPoint = MoveToNextPoint(PathToFollow[current])
        if ArrivedAtNextPoint or ((Player.Position.X, Player.Position.Y) == PathToFollow[current]) : 
            if current+1 < end: Misc.SendMessage('Arrived at target waypoint number %i' % (current), 35)
            current += 1  
        Misc.Pause(itemcd)
            
    Misc.SendMessage('Arrived at final waypoint for current WayPoint List', 35)
    return True

def GoToMoonGate(TupleXYGoTo):
    if TupleXYGoTo in BoardDropOff:
        Misc.SendMessage('The board drop off location is too far to go to. Navigating to the specified crafter moongate', 21)
        global MoongateLoc
        MoongateLoc = PathToCrafterUsingMoongate
        global MoongateDes
        MoongateDes = MoonGateMenuForCrafter
    elif TupleXYGoTo in WayPoints:
        Misc.SendMessage('The next harvest point is too far away, navigating to the specified return moongate', 21)
        global MoongateLoc
        MoongateLoc = PathBackToHarvestUsingMoongate
        global MoongateDes
        MoongateDes = MoonGateMenuForLJ
          
    MoveToNextNode(MoongateLoc, False)
    
    if MoongateDes is not None: 
        UseMoongate(MoongateDes)
        Misc.Pause(2000)
    else:
        Misc.SendMessage('MoongateDes invalid', 35)

def MoveToNextPoint(NextPoint):
    while (Player.Position.X, Player.Position.Y) != NextPoint:
        Misc.SendMessage('--> Calculating route to next way point X: %i and Y: %i ' % (NextPoint[0],NextPoint[1]), 77)
        nextLocation = PathFinding.Route()
        nextLocation.X = NextPoint[0]
        nextLocation.Y = NextPoint[1]
        nextLocation.DebugMessage = False;
        nextLocation.StopIfStuck  = False;
        nextLocation.MaxRetry     = 0;
        PathFind = PathFinding.Go(nextLocation)
        Misc.Pause(itemcd)
        if PathFind: return True 

    
Misc.SendMessage('Starting Script', 55)
## Script starts from here ##

global currentNode
currentNode = 0
if Misc.CheckSharedValue('PrevCoords') :
    #currentNode = Misc.ReadSharedValue('PrevCoords')
    Misc.RemoveSharedValue('PrevCoords')


while True:
    while True:
        if Misc.CheckSharedValue('PrevCoords') :
            currentNode = Misc.ReadSharedValue('PrevCoords')
            Misc.RemoveSharedValue('PrevCoords')
            
        end = len(WayPoints)-1
        
        Arrived = MoveToNextNode([WayPoints[currentNode]])
        if Arrived and currentNode < end: 
            currentNode += 1
            break
        elif Arrived and currentNode >= end:
            Misc.SendMessage('Last resource node reached, reset back to beginning', 35)
            currentNode = 0
            break
        Misc.Pause(itemcd)

    ScanStatic()
    i = 0
    while i < treenumber:
        Arrived = False
        Arrived = MoveToTree(i)
        if Arrived: HarvestResources(i)
        i = i + 1
    
    treeposx = []
    treeposy = []
    treeposz = []
    treegfx = []
    treenumber = 0  